<!--精密空调 -->
<template>
    <div class="jkxt">
        <div class="device-list">
            <div class="device-list-header">设备列表</div>
            <j-tree
                v-model:expandedKeys="expandedKeys"
                v-model:selectedKeys="selectedKeys"
                :tree-data="treeDataList"
                defaultExpandAll
                :fieldNames="{ title: 'name', key: 'id',children:'children' }"
                @select="treeSelect"
            >
                <!-- <template #title="{ title, key }">
                    <span
                        v-if="key === selectedKeys[0]"
                        style="color: #1890ff"
                        >{{ title }}</span
                    >
                    <template v-else>{{ title }}</template>
                </template> -->
            </j-tree>
        </div>
        <div class="video-container">
            <div class="video-container-header">
                <div class="radio-tool">
                    <j-radio-group v-model:value="videoType">
                        <j-radio :value="1">回放</j-radio>
                        <j-radio :value="2">实时监控</j-radio>
                    </j-radio-group>
                </div>
                <div class="switch-tool">
                    <j-space>       
                        <AIcon type="TabletTwoTone" @click="changeWndNum(1)"/>
                        <AIcon type="AppstoreTwoTone" @click="changeWndNum(2)"/>
                        <AIcon type="AppstoreTwoTone" @click="changeWndNum(3)"/>
                    </j-space>
                </div>
            </div>
            <div class="video-list">
                <!-- <div
                    v-for="(item, index) in videoList"
                    :key="index"
                    :id="'divPlugin'+index"
                    class="item"
                >
                    <div class="item-header">
                      <span>摄像头1</span> 
                    <AIcon type="CloseOutlined" />
                    </div>
                    {{ item }}
                </div> -->
                <div id="divPlugin1" class="item"> </div>
            </div>
        </div>
    </div>
</template>
<script lang="ts" name="JKXT" setup>
import type { TreeProps } from 'ant-design-vue';
import { onlyMessage } from '@/utils/comm';

import { queryDeviceTree } from '@/api/monitoring/device';
//import { WebVideoCtrl } from './webVideoCtrl.js'

const treeData: TreeProps['treeData'] = [
    {
        title: 'A座',
        key: '0-0',
        children: [
            {
                title: '库房302',
                key: '0-0-0',
                children: [
                    { title: '摄像头1', key: '0-0-0-0' },
                    { title: '摄像头1', key: '0-0-0-1' },
                ],
            },
            {
                title: '库房303',
                key: '0-0-1',
                children: [{ key: '0-0-1-0', title: '摄像头1' }],
            },
        ],
    },
];
const expandedKeys = ref<string[]>(['0-0-0', '0-0-1']);
const selectedKeys = ref<string[]>(['0-0-0-0']);
const videoType = ref<number>(2);
const videoList = ref<any>([]);

const treeDataList = ref<any>([]);

const currentNVRServer = ref<any>()
const currentSelectWnt = ref<number>(0)

watch(expandedKeys, () => {
    //console.log('expandedKeys', expandedKeys);
});
watch(selectedKeys, () => {
    //console.log('selectedKeys', selectedKeys);
});
onMounted(() => {
    // for (let i = 0; i < 9; i++) {
    //     videoList.value.push(i);
    // }
    queryDeviceTree().then(res=>{
        treeDataList.value = res.result;
    })

    initWebVideo();
});

onBeforeUnmount(()=>{    
    //  WebVideoCtrl.I_DestroyPlugin().then(() => {
    //    console.log("==========I_DestroyPlugin=====success=======")
    // }, (oError:any) => {
    //     console.log("==========I_DestroyPlugin============",oError)
    // });
   if(currentNVRServer.value){

        WebVideoCtrl.I_StopAllPlay({
            success: function () {

            }
        });

        WebVideoCtrl.I_Logout(currentNVRServer.value.ip+'_'+currentNVRServer.value.port).then(() => {
            console.log("==========I_Logout=========ok===")
        }, () => {
            console.log("==========I_Logout=========error===")
        });
   }

    WebVideoCtrl.I_DestroyPlugin().then(function(){
        console.log("==========I_DestroyPlugin=====success=======")
    }, function(oError:any){
        console.log("==========I_DestroyPlugin======error======",oError)
    });


})

const treeSelect=(v:any,o:any)=>{
    //onsole.log("=======treeSelect=========",o)
    if(o.node.deviceType!=='CAMERA'){
        return;
    }    
    var parent =o.node.parent
    if(parent && parent.node.deviceType==='NVR'){
        var serAddr = parent.node.serverAddr.split(":")
        if(serAddr.length>1){ 
            var serObj = {ip:serAddr[0],port:serAddr[1],username:parent.node.username,pwd:parent.node.pwd};
            if(currentNVRServer.value==null) {              
                loginNVR(serObj,false,o.node.serverAddr);
            }else if(serObj.ip !== currentNVRServer.value.ip){
                 loginNVR(serObj,true,o.node.serverAddr);
            }else{
                startRealPlay(o.node.serverAddr)
            }
        }       
    }
    //startRealPlay(v)
}

const loginNVR =(ser:any,reLogin:boolean,iChannelID:number)=>{
    if(reLogin){
        WebVideoCtrl.I_Logout(currentNVRServer.value.ip+'_'+currentNVRServer.value.port).then(() => {
            console.log(currentNVRServer.value.ip + " 退出登录成功！", 'success');
            WebVideoCtrl.I_Login(ser.ip, 1, ser.port, ser.username, ser.pwd, {
                timeout: 3000,
                success: function (xmlDoc:any) {            
                    currentNVRServer.value = ser;
                    console.log(ser.ip + " 登录成功！", 'success');
                    setTimeout(function () {
                        setTimeout(function() {
                            startRealPlay(iChannelID)
                        }, 1000);           
                    }, 10);
                },
                error: function (oError:any) {
                    if (oError === 2001) {
                        onlyMessage(ser.ip + " 已登录过！",'warning');
                    } else {
                        onlyMessage(ser.ip + " 登录失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
                    }
                }
            });
        }, () => {
            console.log("==========I_Logout=========error===")
        });
    }else{
        WebVideoCtrl.I_Login(ser.ip, 1, ser.port, ser.username, ser.pwd, {
                timeout: 3000,
                success: function (xmlDoc:any) {            
                    currentNVRServer.value = ser;
                    console.log(ser.ip + " 登录成功！", 'success');
                    setTimeout(function () {
                        setTimeout(function() {
                           startRealPlay(iChannelID)
                        }, 1000);           
                    }, 10);

                },
                error: function (oError:any) {
                    if (oError === 2001) {
                        onlyMessage(ser.ip + " 已登录过！",'warning');
                    } else {
                        onlyMessage(ser.ip + " 登录失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
                    }
                }
        });
    }
    // var szIP = '223.85.227.237',
    // szPort = '8088',
    // szUsername = 'admin',
    // szPassword = 'rax@2023';
    // if ("" == szIP || "" == szPort) {
    //     return;
    // }
    // var szDeviceIdentify = szIP + "_" + szPort;
    // WebVideoCtrl.I_Login(szIP, 1, szPort, szUsername, szPassword, {
    //     timeout: 3000,
    //     success: function (xmlDoc:any) {            
    //         onlyMessage(szDeviceIdentify + " 登录成功！", 'success');
    //         setTimeout(function () {
    //             setTimeout(function() {
    //                 getChannelInfo(szDeviceIdentify);
    //             }, 1000);
    //             //getDevicePort();                
    //         }, 10);
    //     },
    //     error: function (oError:any) {
    //         if (oError === 2001) {
    //             onlyMessage(szDeviceIdentify + " 已登录过！",'warning');
    //         } else {
    //             onlyMessage(szDeviceIdentify + " 登录失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
    //         }
    //     }
    // });
}

// 获取通道
const getChannelInfo=(szDeviceIdentify:any)=> {     
    // 模拟通道
    WebVideoCtrl.I_GetAnalogChannelInfo(szDeviceIdentify, {
        success: function (xmlDoc:any) {
            console.log("=============模拟通道==============",xmlDoc);  
        },
        error: function (oError:any) {
           // onlyMessage(szDeviceIdentify + " 获取模拟通道失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
        }
    });
    // 数字通道
    WebVideoCtrl.I_GetDigitalChannelInfo(szDeviceIdentify, {
        success: function (xmlDoc:any) {
            console.log("=============数字通道==============",xmlDoc);  
        },
        error: function (oError:any) {
            onlyMessage(szDeviceIdentify + " 获取数字通道失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
        }
    });
    // 零通道
    WebVideoCtrl.I_GetZeroChannelInfo(szDeviceIdentify, {
        success: function (xmlDoc:any) {
           console.log("=============零通道==============",xmlDoc);    
        },
        error: function (oError:any) {
           onlyMessage(szDeviceIdentify + " 获取零通道失败！"+ oError.errorCode+" "+oError.errorMsg,'error');
        }
    });
}



// 开始预览
const startRealPlay = (iChannelID:number)=> {
    var oWndInfo = WebVideoCtrl.I_GetWindowStatus(currentSelectWnt.value)
    //alert(iChannelID)
    //console.log( " 预览"+iChannelID,oWndInfo);
    var realPlay = function () {
        WebVideoCtrl.I_StartRealPlay(currentNVRServer.value.ip+'_'+currentNVRServer.value.port, {
            iStreamType: 1,//1主流码，2子码流，3第三码流，4转码流码
            iChannelID: iChannelID, //通道号
            bZeroChannel: false,
            success: function () {       
                console.log( iChannelID+ " 开始预览",'success');
            },
            error: function (oError:any) {
                onlyMessage( + " 开始预览失败！("+ oError.errorCode+") "+oError.errorMsg,'error');
            }
        });
    };   
    if (oWndInfo != null) {// 已经在播放了，先停止
        WebVideoCtrl.I_Stop({
            success: function () {
                realPlay();
            }
        });
    } else {
        realPlay();
    }
}

const initWebVideo = () => {
    // 初始化插件参数及插入插件
    WebVideoCtrl.I_InitPlugin({
        bWndFull: true,     //是否支持单窗口双击全屏，默认支持 true:支持 false:不支持
        iWndowType: 2,  //分屏类型：1- 1*1，2- 2*2，3- 3*3，4- 4*4 默认值为 1，单画面
        cbSelWnd: function (xmlDoc:any) {
           currentSelectWnt.value=getSelectWndIdx(xmlDoc);
           //g_iWndIndex = parseInt($(xmlDoc).find("SelectWnd").eq(0).text(), 10);
           //var szInfo = "当前选择的窗口编号：" + g_iWndIndex;
           // showCBInfo(szInfo);
        },
        cbDoubleClickWnd: function (iWndIndex:any, bFullScreen:any) {
            var szInfo = "当前放大的窗口编号：" + iWndIndex;
            if (!bFullScreen) {            
                szInfo = "当前还原的窗口编号：" + iWndIndex;
            }
            //showCBInfo(szInfo);
        },
        cbEvent: function (iEventType:any, iParam1:any, iParam2:any) {
            if (2 == iEventType) {// 回放正常结束
                //showCBInfo("窗口" + iParam1 + "回放结束！");
            } else if (-1 == iEventType) {
                //showCBInfo("设备" + iParam1 + "网络错误！");
            } else if (3001 == iEventType) {
                //clickStopRecord(g_szRecordType, iParam1);
            }
        },
        cbInitPluginComplete: function () {
            WebVideoCtrl.I_InsertOBJECTPlugin("divPlugin1").then(() => {
                // 检查插件是否最新
                WebVideoCtrl.I_CheckPluginVersion().then((bFlag:any) => {
                    if (bFlag) {
                        alert("检测到新的插件版本，双击开发包目录里的HCWebSDKPlugin.exe升级！");
                    }
                    console.log("=============初始化插件参数==完成==============")
                    //loginNVR();
                });
            }, () => {
                alert("插件初始化失败，请确认是否已安装插件；如果未安装，请双击开发包目录里的HCWebSDKPlugin.exe安装！");
            });
        }
    });
}

const changeWndNum = (num:number)=>{
    WebVideoCtrl.I_ChangeWndNum(num).then(function(){
        console.log("==========I_DestroyPlugin=====success=======")
    }, function(oError:any){
        console.log("==========I_DestroyPlugin======error======",oError)
    });

}


const getSelectWndIdx = (xmlDoc:any)=>{
    //let xmlDoc = new DOMParser().parseFromString(xmlStr,"text/xml");
    let finds=xmlDoc.getElementsByTagName('SelectWnd');//获取find节点
    if(finds && finds.length>0){
        return finds[0].textContent;
    } 
}

</script>
<style scoped lang="less">
.jkxt {
    width: 100%;
    background: #ffffff;
    border-radius: 4px 4px 4px 4px;
    display: flex;
    .device-list {
        width: 266px;
        height: 100%;
        .device-list-header {
            font-size: 16px;
            font-family: PingFang SC-Medium, PingFang SC;
            font-weight: 500;
            color: #333333;
            line-height: 23px;
            border-left: 3px solid #3468ff;
            padding-left: 5px;
            margin: 16px 8px;
        }
    }
    .video-container {
        flex: 1;
        border-left: 1px solid #e5e5e5;
        .video-container-header {
            display: flex;
            align-items: center;
            justify-content: space-between;
            padding: 16px;
        }
        .video-list {
            display: flex;
            flex-wrap: wrap;
            justify-content: space-around;
            .item {
                width: calc(100% - 20px);
                height: 725px;
                margin-bottom: 16px;
                border-radius: 4px 4px 4px 4px;
                //background: #3468ff;
                overflow: hidden;
                position: relative;

                .item-header {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 34px;
                    background: rgba(42, 55, 78, 0.8);
                    border-radius: 0px 0px 0px 0px;
                    color: white;
                    display: flex;
                    align-items: center;
                    justify-content: space-between;
                    padding: 0 8px;
                }
            }
        }
    }
}
</style>
